/*********************************************************/
/* modlisation d'un moteur  explosion                  */
/* DRAWTOOLS                                             */
/* ----------------------------------------------------- */
/* Georges CAMY / Arnaud QUENUM                          */
/* IMAC Ing3 2002/2003 - Universit de Marne La Valle  */
/* Copyright 2003                                        */
/*********************************************************/
#include "DrawTools.h"





/*********************************************************/
/*                    drawCylinder                       */
/*********************************************************/
void DrawTools::drawCylinder(float r, float h,int dx, int dy,bool plein,double amax){
  int ix,iy;
  double a,pasa =amax/(double)dx,pash=h/(double)dy,x,y;

  for (iy=0; iy<dy; iy++){
     glBegin(GL_QUAD_STRIP);
     for (ix=0,a=0.0; ix<=dx; ix++,a+=pasa){
        x = r*cos(a);
	y = r*sin(a);
	glNormal3f(x,y,1.0f);
        glTexCoord2d(a/amax,(double)(iy+1)/dy);
	glVertex3d(x,y,(double)(iy+1)*pash);
	glTexCoord2d(a/amax,(double)(iy)/dy);
	glVertex3d(x,y,(double)iy*pash);
     }
     glEnd();
  }

  if (plein){
     glNormal3f(0.0f,0.0f,-1.0f);
     glBegin(GL_TRIANGLE_FAN);
     glTexCoord2d(0.0,0.0);
     glVertex3f(0.0,0.0,0.0);
     for (ix=0,a=amax; ix<=dx; ix++,a-=pasa){
        x = r*cos(a);
	y = r*sin(a);
	glTexCoord2d(x,y);
	glVertex3d(x,y,0.0);
     }
     glEnd();
     glNormal3f(0.0f,0.0f,1.0f);
     glBegin(GL_TRIANGLE_FAN);
     glTexCoord2d(0.0,0.0);
     glVertex3f(0.0,0.0,h);
     for (ix=0,a=0.0; ix<=dx; ix++,a+=pasa){
       x = r*cos(a);
       y = r*sin(a);
       glTexCoord2d(x,y);
       glVertex3d(x,y,h);
     }
     glEnd();
  }
}


void DrawTools::drawCylinder(float r, float h,int dx, int dy,bool plein){
  double amax=2.0*M_PI;
  int ix,iy;
  double a,pasa =amax/(double)dx,pash=h/(double)dy,x,y;

  for (iy=0; iy<dy; iy++){
     glBegin(GL_QUAD_STRIP);
     for (ix=0,a=0.0; ix<=dx; ix++,a+=pasa){
        x = r*cos(a);
	y = r*sin(a);
	glNormal3f(x,y,0.0f);
        glTexCoord2d(a/amax,(double)(iy+1)/dy);
	glVertex3d(x,y,(double)(iy+1)*pash);
	glTexCoord2d(a/amax,(double)(iy)/dy);
	glVertex3d(x,y,(double)iy*pash);
     }
     glEnd();
  }

  if (plein){
     glNormal3f(0.0f,0.0f,-1.0f);
     glBegin(GL_TRIANGLE_FAN);
     glTexCoord2d(0.0,0.0);
     glVertex3f(0.0,0.0,0.0);
     for (ix=0,a=amax; ix<=dx; ix++,a-=pasa){
        x = r*cos(a);
	y = r*sin(a);
	glTexCoord2d(x,y);
	glVertex3d(x,y,0.0);
     }
     glEnd();
     glNormal3f(0.0f,0.0f,1.0f);
     glBegin(GL_TRIANGLE_FAN);
     glTexCoord2d(0.0,0.0);
     glVertex3f(0.0,0.0,h);
     for (ix=0,a=0.0; ix<=dx; ix++,a+=pasa){
       x = r*cos(a);
       y = r*sin(a);
       glTexCoord2d(x,y);
       glVertex3d(x,y,h);
     }
     glEnd();
  }
}



void DrawTools::drawInvertedCylinder(float r, float h,int dx, int dy,bool plein,double amax){
  int ix,iy;
  double a,pasa =amax/(double)dx,pash=h/(double)dy,x,y;

  for (iy=0; iy<dy; iy++){
     glBegin(GL_QUAD_STRIP);
     for (ix=0,a=0.0; ix<=dx; ix++,a+=pasa){
        x = r*cos(a);
	y = r*sin(a);
	glNormal3f(x,y,-1.0f);
        glTexCoord2d(a/amax,(double)(iy+1)/dy);
	glVertex3d(x,y,(double)(iy+1)*pash);
	glTexCoord2d(a/amax,(double)(iy)/dy);
	glVertex3d(x,y,(double)iy*pash);
     }
     glEnd();
  }

  if (plein){
     glNormal3f(0.0f,0.0f,-1.0f);
     glBegin(GL_TRIANGLE_FAN);
     glTexCoord2d(0.0,0.0);
     glVertex3f(0.0,0.0,0.0);
     for (ix=0,a=amax; ix<=dx; ix++,a-=pasa){
        x = r*cos(a);
	y = r*sin(a);
	glTexCoord2d(x,y);
	glVertex3d(x,y,0.0);
     }
     glEnd();
     glNormal3f(0.0f,0.0f,-1.0f);
     glBegin(GL_TRIANGLE_FAN);
     glTexCoord2d(0.0,0.0);
     glVertex3f(0.0,0.0,h);
     for (ix=0,a=0.0; ix<=dx; ix++,a+=pasa){
       x = r*cos(a);
       y = r*sin(a);
       glTexCoord2d(x,y);
       glVertex3d(x,y,h);
     }
     glEnd();
  }
}
/*********************************************************/
/*                    drawText                           */
/* Taille de la police de 1 (petit)  3 (grand)          */
/*********************************************************/
void DrawTools::drawText(char * chaine, int size){
  switch (size){
     case 2:
        while(*chaine != '\0'){
           glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, *chaine);
           chaine++;
        }
        break;
     case 3:
        while(*chaine != '\0'){
           glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18, *chaine);
           chaine++;
        }
        break;
     default:
       while(*chaine != '\0'){
           glutBitmapCharacter(GLUT_BITMAP_HELVETICA_10, *chaine);
           chaine++;
        }
        break;
  }
}
