/*********************************************************/
/* modlisation d'un moteur  explosion                  */
/* GAZ                                                   */
/* ----------------------------------------------------- */
/* Georges CAMY / Arnaud QUENUM                          */
/* IMAC Ing3 2002/2003 - Universit de Marne La Valle  */
/* Copyright 2003                                        */
/*********************************************************/
#include "Gaz.h"

/*********************************************************/
/*                    constructeur                       */
/*********************************************************/
Gaz::Gaz(){

  // dimensions
  d = 1.5;
  l = 5.0;
  e = 0.1;

  // initialisation angles
  alpha_r = 0;
  beta_r = 0;
  beta_d = 0;
}



/*********************************************************/
/*                    dessiner                           */
/*********************************************************/
void Gaz::dessiner(float alpha_d){

   // fonction de transparence
   glBlendFunc(GL_SRC_ALPHA, GL_ONE);
   glEnable(GL_BLEND);

   //Angles
   alpha_r = (double)((alpha_d*M_PI)/180);
   beta_r = (double)(asin(d*sin(alpha_r)/l));
   xpiston = d*cos(alpha_r) + l*cos(beta_r) - ((l+d)/2);

   // matriel du gaz
   float mat_ambi_gaz[]= {0.2,0.2,0.1}, mat_diff_gaz[]= {0.8,0.8,0.2,0.5},
         mat_spec_gaz[]= {0.8,0.8,0.8},mat_nphong_gaz=20.0;

   glMaterialfv(GL_FRONT,GL_AMBIENT,mat_ambi_gaz);
   glMaterialfv(GL_FRONT,GL_DIFFUSE,mat_diff_gaz);
   glMaterialfv(GL_FRONT,GL_SPECULAR,mat_spec_gaz);
   glMaterialf(GL_FRONT,GL_SHININESS,mat_nphong_gaz);

   // gaz dans le tube du piston
   glPushMatrix();
   glTranslatef(xpiston+3.3,0.0,5*e/2);
   glRotatef(90,0,1,0);
   DrawTools::drawCylinder(2.1,4.3-xpiston,35,1,true);
   glPopMatrix();

   // mlange essence air
   if ((alpha_d > 45) && (alpha_d < 135)){
     glPushMatrix();
     glTranslatef(8.9,2.8,0.3);
     glScalef(1.4,4.4,1.4);
     glutSolidCube(1);
     glPopMatrix();
     glPushMatrix();
     glTranslatef(7.5,1,0);
     glRotatef(90,0,1,0);
     DrawTools::drawCylinder(0.8,1.5,12,1,true);
     glPopMatrix();
   }

   // gaz brls
   if ((alpha_d > 585) && (alpha_d < 675)){
     glPushMatrix();
     glTranslatef(8.9,-2.8,0.3);
     glScalef(1.4,4.4,1.4);
     glutSolidCube(1);
     glPopMatrix();
     glPushMatrix();
     glTranslatef(7.5,-1,0);
     glRotatef(90,0,1,0);
     DrawTools::drawCylinder(0.8,1.5,12,1,true);
     glPopMatrix();
   }
   glDisable(GL_BLEND);
}

