/*********************************************************/
/* modlisation d'un moteur  explosion                  */
/* MOTEUR                                                */
/* ----------------------------------------------------- */
/* Georges CAMY / Arnaud QUENUM                          */
/* IMAC Ing3 2002/2003 - Universit de Marne La Valle  */
/*  Copyright 2003                                       */
/*********************************************************/
#include "moteur.h"

// Taille du tampon de la slection
#define _SELECTION_BUFFER_SIZE 1024

// souris
#define _MOUSE_WHEEL_UP 3
#define _MOUSE_WHEEL_DOWN 4

// toursParSec
#define _TOURS_PAR_SEC_INIT 0.1

// ELEMENTS
#define _ELEMENT_AUCUN 0
#define _ELEMENT_CAISSON 1
#define _ELEMENT_PISTON 2
#define _ELEMENT_SOUPAPES 3
#define _LUMIERE_BLINK_INIT 5


/*********************************************************/
/*              Dfintions: fentre                      */
/*********************************************************/
int windowWidth=800;
int windowHeight=600;
GLfloat windowRapport;



/*********************************************************/
/*              Dfintions: commandes                    */
/*********************************************************/
bool explications = true;
bool aide = true;
bool showFps = false;
GLdouble fps = 0;
bool reperesSpots = false;
bool lumiere = false;
bool lumiereBlink = false;
GLdouble lumiereTemps = glutGet(GLUT_ELAPSED_TIME);
int lumiereBlinkNumber = _LUMIERE_BLINK_INIT;
bool caisson = true;
bool texture = false;
bool gaz = true;
int elementSelectione = _ELEMENT_PISTON;



/*********************************************************/
/*              Dfintions: variables de mouvement       */
/*********************************************************/
GLdouble cycle = 0.0;
GLdouble temps = glutGet(GLUT_ELAPSED_TIME);
GLdouble toursParSec = _TOURS_PAR_SEC_INIT;



/*********************************************************/
/*                    Dfintions: camra                 */
/*********************************************************/
GLdouble thetaOeil=6.963, phiOeil=-3.5996, distOeil=10.0;
GLdouble oeilx=distOeil*cos(thetaOeil)*cos(phiOeil),
         oeily=distOeil*sin(thetaOeil)*cos(phiOeil),
	 oeilz=distOeil*sin(phiOeil),
	 visex=0.0,
	 visey=0.0,
	 visez=0.5;

// abscisse du clic
int xold;
// ordonne du clic
int yold, y_zoom_old;
//'vitesse' de mouvance
int dist_x, dist_y, dist_yzoom;

// zoom
GLdouble zoom = 0.2;

//Boutons de la souris
bool left, right;



/*********************************************************/
/*                    Dfintions: lumires               */
/*********************************************************/

// lumire 0 : lumire ambiante
GLfloat Light0Pos[4]  = {0.0,10.0,0.0,1.0};
GLfloat Light0Amb[4]  = {0.4, 0.4, 0.4, 0.3};
GLfloat Light0Dif[4]  = {0.8, 0.8, 0.8, 0.3};
GLfloat Light0Spec[4] = {0.3, 0.3, 0.3, 0.01};
// lumire 1 : bougie
GLfloat Light1Pos[4]  = {0.0, 0.0, 0.0, 1.0};
GLfloat Light1Amb[4]  = {0.01, 0.01, 0.01, 0.1};
GLfloat Light1Dif[4]  = {1.0, 1.0, 1.0, 1.0};
GLfloat Light1Spec[4] = {1.0, 1.0, 1.0, 1.0};
// lumire 1 : spot 1
GLfloat Light2Pos[4]  = {0.0, 0.0, 0.0, 1.0};
GLfloat Light2Amb[4]  = {0.5, 0.2, 0.3, 0.6};
GLfloat Light2Dif[4]  = {0.5, 0.2, 0.3, 0.8};
GLfloat Light2Spec[4] = {0.2, 0.1, 0.2, 0.01};
// lumire 3 : spot 2
GLfloat Light3Pos[4]  = {0.0, 0.0, 0.0, 1.0};
GLfloat Light3Amb[4]  = {0.3, 0.3, 0.5, 0.4};
GLfloat Light3Dif[4]  = {0.3, 0.3, 0.5, 0.3};
GLfloat Light3Spec[4] = {0.2, 0.2, 0.3, 0.01};
// lumire 4 : spot 3
GLfloat Light4Pos[4]  = { 0.0, 0.0, 0.0, 1.0};
GLfloat Light4Amb[4]  = { 0.2, 0.2, 0.4, 0.3};
GLfloat Light4Dif[4]  = { 0.2, 0.2, 0.4, 0.4};
GLfloat Light4Spec[4] = { 0.0, 0.0, 0.0, 0.01};



/*********************************************************/
/*              Dfintions: pointeurs objets             */
/*********************************************************/
Repere *mon_repere;
Caisson *mon_caisson;
Piston *mon_piston;
Gaz *mon_gaz;
Soupape *ma_soupape1;
Soupape *ma_soupape2;



/*********************************************************/
/*              Prototypes des fonctions                 */
/*********************************************************/
static void drawFunc(void);
static void reshapeFunc(int w,int h);
static void kbdFunc(unsigned char c, int x, int y);
static void kbdSpecialFunc(int c, int x, int y);
static void mouseFunc(int button, int state, int x, int y);
static void motionFunc(int x, int y);
static void idleFunc();
void dessinerSceneNommee();
void processHits(GLint hits, GLuint buffer[]);
void selection(int x, int y);
static void init();
void credits (void);
int main(int argc, char** argv);



/*********************************************************/
/* fonction de dessin de la scne  l'cran              */
/*********************************************************/
static void drawFunc(void){
  // Tampons texte
  char textBuffer1[100];
  char textBuffer2[100];
  char textBuffer3[100];
  char textBuffer4[100];

  // initialisation des buffers : couleur et ZBuffer
  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

  // modification de la matrice de la scne
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();

  // lumire 0 : globale diffuse
  glLightfv(GL_LIGHT0, GL_POSITION,Light0Pos);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, Light0Dif);
  glLightfv(GL_LIGHT0, GL_SPECULAR,Light0Spec);
  glLightfv(GL_LIGHT0, GL_AMBIENT, Light0Amb);

  // placement de la scne en fonction de la camra
  gluLookAt(oeilx,oeily,oeilz,visex,visey,visez,0.0,0.0,1.0);

  // Zoom
  glScalef(zoom,zoom,zoom);

  // lumire 1 : bougie
  glPushMatrix();
  glTranslatef(6.8,0.0,0.0);
  //mon_repere->dessiner();
  glLightfv(GL_LIGHT1, GL_POSITION, Light1Pos);
  glLightfv(GL_LIGHT1, GL_DIFFUSE, Light1Dif);
  glLightfv(GL_LIGHT1, GL_SPECULAR, Light1Spec);
  glLightfv(GL_LIGHT1, GL_AMBIENT, Light1Amb);
  glLightf(GL_LIGHT1, GL_CONSTANT_ATTENUATION, 0.3);
  GLfloat Spot1Dir[3]   = {-1.0, 0.0, 0.0};
  glLightfv(GL_LIGHT1, GL_SPOT_DIRECTION, Spot1Dir);
  glLightf(GL_LIGHT1, GL_SPOT_CUTOFF, 100.0);
  glLightf(GL_LIGHT1, GL_SPOT_EXPONENT, 50.0);
  glPopMatrix();
  if (cycle>350 && cycle<370) glEnable(GL_LIGHT1);
  else glDisable(GL_LIGHT1);

  // lumire 2 : spot stable 1
  glPushMatrix();
  glTranslatef(12.0, 6.0, 3.0);
  if (reperesSpots) mon_repere->dessiner();
  glLightfv(GL_LIGHT2, GL_POSITION, Light2Pos);
  glLightfv(GL_LIGHT2, GL_DIFFUSE, Light2Dif);
  glLightfv(GL_LIGHT2, GL_SPECULAR, Light2Spec);
  glLightfv(GL_LIGHT2, GL_AMBIENT, Light2Amb);
  GLfloat Spot2Dir[3]   = {-0.3, -0.8, -0.50};
  glLightfv(GL_LIGHT2, GL_SPOT_DIRECTION, Spot2Dir);
  glLightf(GL_LIGHT2, GL_SPOT_CUTOFF, 70.0);
  glLightf(GL_LIGHT2, GL_SPOT_EXPONENT, 2.0);
  glPopMatrix();

  // lumire 3 : spot stable 2
  glPushMatrix();
  glTranslatef(-1.0,0.0,2.5);
  if (reperesSpots) mon_repere->dessiner();
  glLightfv(GL_LIGHT3, GL_POSITION, Light3Pos);
  glLightfv(GL_LIGHT3, GL_DIFFUSE, Light3Dif);
  glLightfv(GL_LIGHT3, GL_SPECULAR, Light3Spec);
  glLightfv(GL_LIGHT3, GL_AMBIENT, Light3Amb);
  GLfloat Spot3Dir[3]   = {-1.0, 0.0, -0.35};
  glLightfv(GL_LIGHT3, GL_SPOT_DIRECTION, Spot3Dir);
  glLightf(GL_LIGHT3, GL_SPOT_CUTOFF, 70.0);
  glLightf(GL_LIGHT3, GL_SPOT_EXPONENT, 2.0);
  glPopMatrix();

  // lumire 4 : spot stable 3
  glPushMatrix();
  glTranslatef(2.0,-5.0,-3.0);
  if (reperesSpots) mon_repere->dessiner();
  glLightfv(GL_LIGHT4, GL_POSITION, Light4Pos);
  glLightfv(GL_LIGHT4, GL_DIFFUSE, Light4Dif);
  glLightfv(GL_LIGHT4, GL_SPECULAR, Light4Spec);
  glLightfv(GL_LIGHT4, GL_AMBIENT, Light4Amb);
  GLfloat Spot4Dir[3]   = {-1.0, 0.8, 0.5};
  glLightfv(GL_LIGHT4, GL_SPOT_DIRECTION, Spot4Dir);
  glLightf(GL_LIGHT4, GL_SPOT_CUTOFF, 90.0);
  glLightf(GL_LIGHT4, GL_SPOT_EXPONENT, 2.0);
  glPopMatrix();

  // soupapes
  if (elementSelectione == _ELEMENT_SOUPAPES){
     glDisable(GL_LIGHTING);
     glColor3d(1,1,1);
     glRasterPos3d(9.0,-1.0,2.5);
     sprintf(textBuffer1,"Soupapes");
     DrawTools::drawText(textBuffer1,3);
     glRasterPos3d(9.0,-3.0,1.5);
     sprintf(textBuffer1,"Echappement");
     DrawTools::drawText(textBuffer1,2);
     glRasterPos3d(9.0,3.0,1.5);
     sprintf(textBuffer1,"Admission");
     DrawTools::drawText(textBuffer1,2);
     glEnable(GL_LIGHTING);
     glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
  }
  else if (elementSelectione == _ELEMENT_AUCUN){
     glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
  }
  else glPolygonMode(GL_FRONT,GL_LINE);
  // premire soupape
  glPushMatrix();
  if (cycle>=0 && cycle<90) glTranslatef(7.5 + cycle*0.015,1,0);
  else if (cycle>=90 && cycle<180) glTranslatef(7.5 + 1.35 -(cycle-90)*0.015,1,0);
  else glTranslatef(7.5,1,0);
  ma_soupape1->dessiner();
  glPopMatrix();
  // deuxime soupape
  glPushMatrix();
  if (cycle>=540 && cycle<630) glTranslatef(7.5 + (cycle-540)*0.015,-1,0);
  else if (cycle>=630) glTranslatef(7.5 + 1.35 -(cycle-630)*0.015,-1,0);
  else glTranslatef(7.5,-1,0);
  ma_soupape2->dessiner();
  glPopMatrix();

  // piston
  if (elementSelectione == _ELEMENT_PISTON){
     glDisable(GL_LIGHTING);
     glColor3d(1,1,1);
     glRasterPos3d(0.0,-1.0,2.8);
     sprintf(textBuffer1,"Piston");
     DrawTools::drawText(textBuffer1,3);
     glRasterPos3d(-5.0,0.0,1.5);
     sprintf(textBuffer1,"Vilebrequin");
     DrawTools::drawText(textBuffer1,2);
     glEnable(GL_LIGHTING);
     glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
  }
  else if (elementSelectione == _ELEMENT_AUCUN){
     glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
  }
  else glPolygonMode(GL_FRONT,GL_LINE);
  mon_piston->dessiner(cycle);

  // caisson
  if (caisson){
     glPushMatrix();
     if (elementSelectione == _ELEMENT_CAISSON){
        glDisable(GL_LIGHTING);
	glColor3d(1,1,1);
	glRasterPos3d(5.0,0.0,2.8);
	sprintf(textBuffer1,"Caisson");
	DrawTools::drawText(textBuffer1,3);
	glRasterPos3d(9.0,-3.0,1.5);
	sprintf(textBuffer1,"Collecteur d'echappement");
	DrawTools::drawText(textBuffer1,2);
	glRasterPos3d(9.0,3.0,1.5);
	sprintf(textBuffer1,"Tubulure d'admission");
	DrawTools::drawText(textBuffer1,2);
	glRasterPos3d(7.0,0.0,1.5);
	sprintf(textBuffer1,"Bougie");
	DrawTools::drawText(textBuffer1,2);
	glEnable(GL_LIGHTING);
	glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
      }
      else if (elementSelectione == _ELEMENT_AUCUN){
         glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
      }
      else glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
      mon_caisson->dessiner(texture);
      glPopMatrix();
  }

  // gaz
  if (gaz){
     glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
     glPushMatrix();
     mon_gaz->dessiner(cycle);
     glPopMatrix();
  }


  // fin de la partie 3D. Voir plus haut "modification de la matrice de la scne"
  glPopMatrix();


  // 2D Text
  glMatrixMode(GL_PROJECTION);
  glPushMatrix();
     glLoadIdentity();
     gluOrtho2D(0.0,windowWidth,0,windowHeight);
     glMatrixMode(GL_MODELVIEW);
     glPushMatrix();
        glDisable(GL_LIGHTING);
	glColor3d(1,1,1);

	// Titre
	/*
        glRasterPos2d(0.30*windowWidth,0.90*windowHeight);
        sprintf(textBuffer1,"Moteur a explosion (4 temps, essence)");
        DrawTools::drawText(textBuffer1,3);
*/
	// Vitesse
        glRasterPos2d(0.01*windowWidth,0.15*windowHeight);
        sprintf(textBuffer1,"Vitesse: %2.1f tours/sec", toursParSec);
        DrawTools::drawText(textBuffer1,1);

	// Copyright
        glRasterPos2d(0.83*windowWidth,0.02*windowHeight);
        sprintf(textBuffer1,"(c) 2003 CAMY / QUENUM");
        DrawTools::drawText(textBuffer1,1);

	// fps
	if (showFps){
	   sprintf(textBuffer1,"FPS: %2.1f",fps);
	   glRasterPos2d(0.93*windowWidth,0.98*windowHeight);
	   DrawTools::drawText(textBuffer1,2);
	}

	// Affichage du temps en cours
        if (cycle>=540){
	   sprintf(textBuffer1,"Temps 4: Echappement");
	   sprintf(textBuffer2,"Arrive en fin de detente et en bas du cylindre, le piston");
	   sprintf(textBuffer3,"remonte. La soupape d'echappement est ouverte, et les gaz");
	   sprintf(textBuffer4,"brules peuvent s'evacuer par le collecteur d'echappement.");
	}
	else if (cycle>=360){
	   sprintf(textBuffer1,"Temps 3: Explosion");
	   sprintf(textBuffer2,"Une etincelle vient amorcer la combustion du melange.");
	   sprintf(textBuffer3,"Il s'en suit une inflammation du melange, qui produit une detente");
	   sprintf(textBuffer4,"de celui-ci. Du coup, le piston redescend avec une force importante.");
	}
	else if (cycle>=180){
	   sprintf(textBuffer1,"Temps 2: Compression");
   	   sprintf(textBuffer2,"La soupape d'admission se ferme. Le piston remonte en comprimant");
	   sprintf(textBuffer3,"les gaz. Il se produit un echauffement qui amene l'air ou");
	   sprintf(textBuffer4,"le melange a une temperature qui favorise l'explosion.");
	}
	else {
	   sprintf(textBuffer1,"Temps 1: Admission");
	   sprintf(textBuffer2,"La soupape d'admission est ouverte, celle d'echappement");
	   sprintf(textBuffer3,"est fermee. Le piston descend, aspirant ainsi le melange ");
	   sprintf(textBuffer4,"qui se trouve dans la tubulure d'admission.");
	}
        glRasterPos2d(0.01*windowWidth,0.11*windowHeight);
	DrawTools::drawText(textBuffer1,2);
        if (explications){
	   glRasterPos2d(0.01*windowWidth,0.08*windowHeight);
	   DrawTools::drawText(textBuffer2,1);
           glRasterPos2d(0.01*windowWidth,0.06*windowHeight);
	   DrawTools::drawText(textBuffer3,1);
           glRasterPos2d(0.01*windowWidth,0.04*windowHeight);
	   DrawTools::drawText(textBuffer4,1);
	}

	// aide
	if (aide){
	   sprintf(textBuffer1,"COMMANDES CLAVIER");
	   glRasterPos2d(0.01*windowWidth,0.87*windowHeight);
	   DrawTools::drawText(textBuffer1,2);
	   sprintf(textBuffer1,"a : aide");
	   glRasterPos2d(0.01*windowWidth,0.84*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
	   sprintf(textBuffer1,"q : quitter");
   	   glRasterPos2d(0.01*windowWidth,0.82*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
	   sprintf(textBuffer1," l : lumiere");
	   glRasterPos2d(0.01*windowWidth,0.80*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
	   sprintf(textBuffer1,"e : explications detaillees");
	   glRasterPos2d(0.01*windowWidth,0.78*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
	   sprintf(textBuffer1,"f : afficher fps");
	   glRasterPos2d(0.01*windowWidth,0.76*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
	   sprintf(textBuffer1,"t : afficher les textures");
	   glRasterPos2d(0.01*windowWidth,0.74*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
   	   sprintf(textBuffer1,"r : afficher les reperes des spots");
	   glRasterPos2d(0.01*windowWidth,0.72*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
	   sprintf(textBuffer1,"1 : moteur entier");
	   glRasterPos2d(0.01*windowWidth,0.70*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
	   sprintf(textBuffer1,"2 : caisson");
	   glRasterPos2d(0.01*windowWidth,0.68*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
	   sprintf(textBuffer1,"3 : piston");
	   glRasterPos2d(0.01*windowWidth,0.66*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
	   sprintf(textBuffer1,"4 : soupapes");
	   glRasterPos2d(0.01*windowWidth,0.64*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
	   sprintf(textBuffer1,"5 : afficher gaz (pas encore implemente)");
	   glRasterPos2d(0.01*windowWidth,0.62*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
   	   sprintf(textBuffer1,"6 : afficher caisson");
	   glRasterPos2d(0.01*windowWidth,0.60*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
   	   sprintf(textBuffer1,"+ : augmenter vitesse");
	   glRasterPos2d(0.01*windowWidth,0.58*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
   	   sprintf(textBuffer1,"- : diminuer vitesse");
	   glRasterPos2d(0.01*windowWidth,0.56*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
   	   sprintf(textBuffer1,"touches directionnelles : tourner camera");
	   glRasterPos2d(0.01*windowWidth,0.54*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
	   sprintf(textBuffer1,"COMMANDES SOURIS");
	   glRasterPos2d(0.01*windowWidth,0.45*windowHeight);
	   DrawTools::drawText(textBuffer1,2);
	   sprintf(textBuffer1,"clic gauche                  : selectionner objet");
	   glRasterPos2d(0.01*windowWidth,0.42*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
	   sprintf(textBuffer1,"clic gauche + deplacer : bouger camera");
	   glRasterPos2d(0.01*windowWidth,0.40*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
   	   sprintf(textBuffer1,"clic droit + deplacer    : zoomer");
	   glRasterPos2d(0.01*windowWidth,0.38*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
	   sprintf(textBuffer1,"molette avant             : augmenter vitesse");
	   glRasterPos2d(0.01*windowWidth,0.36*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
	   sprintf(textBuffer1,"molette arriere            : diminuer vitesse");
	   glRasterPos2d(0.01*windowWidth,0.34*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
	   sprintf(textBuffer1,"clic molette                 : reinitialiser vitesse");
	   glRasterPos2d(0.01*windowWidth,0.32*windowHeight);
	   DrawTools::drawText(textBuffer1,1);
	}

	glEnable(GL_LIGHTING);
     glPopMatrix();
     glMatrixMode(GL_PROJECTION);
  glPopMatrix();

  // changement de buffer d'affichage
  glutSwapBuffers();
}



/*********************************************************/
/* fonction de changement de dimension de la fenetre     */
/* paramtres :                                          */
/* - width : largeur (x) de la zone de visualisation     */
/* - height : hauteur (y) de la zone de visualisation    */
/*********************************************************/
static void reshapeFunc(int w,int h){
  
  // Rapport entre largeur et hauteur de la fenetre
  windowRapport=(float)w/(float)h;
  // dimension de l'cran GL
  glViewport(0, 0, (GLint)w, (GLint)h);
  // construction de la matrice de projection
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  // dfinition de la camera
  gluPerspective(20.0,windowRapport,1.0,20.0 );
  // initialisation de la matrice de la scne
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
}



/*********************************************************/
/* fonction associe aux interruptions clavier           */
/* paramtres :                                          */
/* - c : caractre saisi                                 */
/* - x,y : coordonne du curseur dans la fentre         */
/*********************************************************/
static void kbdFunc(unsigned char c, int x, int y){
  switch(c)
  {
     // quitter le programme avec les touches ESC, 'q' ou 'Q'
     case 27 : case 'q' : case 'Q' :
	exit(0);
        break;
     // afficher l'aide
     case 'a' : case 'A' :
        aide = !aide;
	break;
     // afficher l'aide
     case 'f' : case 'F' :
        showFps = !showFps;
	break;
     // afficher explications
     case 'e' : case 'E' :
        explications = !explications;
	break;
     // afficher lumires
     case 'l' : case 'L' :
	lumiereBlink = true;
	break;
     // texture (pour les ordinateurs qui rament comme le mien)
     case 't' : case 'T' :
        texture = !texture;
	break;
     // afficher les reperes des spots
     case 'r' : case 'R' :
        reperesSpots = !reperesSpots;
	break;
     // moteur entier
     case '1' :
        elementSelectione = _ELEMENT_AUCUN;
	break;
     // caisson
     case '2' :
        elementSelectione = _ELEMENT_CAISSON;
	break;
     // piston
     case '3' :
        elementSelectione = _ELEMENT_PISTON;
	break;
     // soupapes
     case '4' :
        elementSelectione = _ELEMENT_SOUPAPES;
	break;
     // afficher gaz
     case '5' :
        gaz =!gaz;
	break;
     // afficher caisson
     case '6' :
        caisson = !caisson;
	break;
     // diminuer vitesse
     case '-' :
        toursParSec = toursParSec - 0.1;
	break;
     // augmenter vitesse
     case '+' :
        toursParSec = toursParSec + 0.1;
	break;
  }
  glutPostRedisplay();
}



/*********************************************************/
/* fonction associe aux interruptions clavier           */
/* paramtres :                                          */
/* - c : caractre saisi                                 */
/* - x,y : coordonne du curseur dans la fentre         */
/*********************************************************/
static void kbdSpecialFunc(int c, int x, int y){
   switch (c){ 
      case GLUT_KEY_UP : phiOeil += 0.1; break;
      case GLUT_KEY_DOWN : phiOeil -= 0.1; break;
      case GLUT_KEY_RIGHT : thetaOeil += 0.1; break;
      case GLUT_KEY_LEFT : thetaOeil -= 0.1; break;
      case GLUT_KEY_PAGE_UP : distOeil *= 1.1; break;
      case GLUT_KEY_PAGE_DOWN : distOeil /= 1.1; break;
   }
   oeilx=distOeil*cos(thetaOeil)*cos(phiOeil);
   oeily=distOeil*sin(thetaOeil)*cos(phiOeil);
   oeilz=distOeil*sin(phiOeil);
   glutPostRedisplay();
}



/*********************************************************/
/* fonction associe au clique de la souris              */
/* paramtres :                                          */
/* - button : nom du bouton press GLUT_LEFT_BUTTON,     */
/*   GLUT_MIDDLE_BUTTON ou GLUT_RIGHT_BUTTON             */
/* - state : tat du bouton button GLUT_DOWN ou GLUT_UP  */
/* - x,y : coordonne du curseur dans la fentre         */
/*********************************************************/
static void mouseFunc(int button, int state, int x, int y){
  if(state == GLUT_DOWN && button == GLUT_LEFT_BUTTON){
     // selectioner
     selection(x,y);
     xold=x;
     yold=y;
     left=true;
     right=false;
  }
  else if(state == GLUT_DOWN && button == GLUT_RIGHT_BUTTON){
     // zoomer
     y_zoom_old=y;
     left=false;
     right=true;
  }
  else if(state == GLUT_DOWN && button == GLUT_MIDDLE_BUTTON){
     // reinitialiser vitesse
     toursParSec = _TOURS_PAR_SEC_INIT;
  }
  else if(state == GLUT_DOWN && button == _MOUSE_WHEEL_UP){
     // diminuer vitesse
     toursParSec = toursParSec - 0.1;
   }
  else if(state == GLUT_DOWN && button == _MOUSE_WHEEL_DOWN){
     // augmenter vitesse
     toursParSec = toursParSec + 0.1;
  }
}



/*********************************************************/
/* fonction associe au dplacement de la souris bouton  */
/* enfonc.                                              */
/* paramtres :                                          */
/* - x,y : coordonne du curseur dans la fentre         */
/*********************************************************/
static void motionFunc(int x, int y){
   if(left){
      dist_x = xold - x;
      dist_y = yold - y;

      // On ne tient pas compte des petites variations du curseur
      if(abs(dist_x)<=20){
         dist_x=0;
      }
      if(abs(dist_y)<=20){
         dist_y=0;
      }

      thetaOeil += dist_x*0.001;
      phiOeil += dist_y*0.001;

      x=xold;
      y=yold;
   }
   else if(right){
      dist_yzoom = y_zoom_old - y;
      zoom += (dist_yzoom*0.0001);
      if (zoom < 0) zoom = 0;

      // pour un zoom 'rel' de la camra:
      // distOeil += (dist_yzoom*0.001);
   }

   oeilx=distOeil*cos(thetaOeil)*cos(phiOeil);
   oeily=distOeil*sin(thetaOeil)*cos(phiOeil);
   oeilz=distOeil*sin(phiOeil);
   glutPostRedisplay();
}



/*********************************************************/
/* fonction excute par OpenGL lorsqu'il n'y a pas de   */
/* traitement d'affichage  raliser.                    */
/*********************************************************/
static void idleFunc(){
  
  // calcul du temps coul (en millisecondes)
  GLdouble deltaTemps = glutGet(GLUT_ELAPSED_TIME)-temps;

  // cycle exprim en tours par seconde
  cycle = cycle + toursParSec*360 * ( deltaTemps / 1000);
  // Remarque: operateur modulo % pas dfini pour GL_double
  if (cycle > 720){
     cycle = cycle -720;
  }
  else if(cycle < 0){
     cycle = cycle + 720;
  }


  // fps
  fps = 1 / (deltaTemps/1000);


  // clignotement lumiere (au maximum un par 100*2=200ms)
  if (lumiereBlink && (glutGet(GLUT_ELAPSED_TIME)-lumiereTemps > 100 )){
     lumiereTemps = glutGet(GLUT_ELAPSED_TIME);
     lumiereBlinkNumber = lumiereBlinkNumber - 1;
     if (lumiere){
        glDisable(GL_LIGHT0);
        lumiere = !lumiere;
      }
     else{
        glEnable(GL_LIGHT0);
        lumiere = !lumiere;
     }
  }
  if (lumiereBlinkNumber == 0){
     lumiereBlinkNumber = _LUMIERE_BLINK_INIT;
     lumiereBlink = false;
  }

  // sauvegarde du temps actuel
  temps = glutGet(GLUT_ELAPSED_TIME);

  // reaffichage
  glutPostRedisplay();
}


/*********************************************************/
/* fonction de dessin de la scne cliquable              */
/*********************************************************/
void dessinerSceneNommee(){
  
  // soupapes : objet 3
  glLoadName(3); // premire soupape
  glPushMatrix();
  if (cycle>=0 && cycle<90) glTranslatef(7.5 + cycle*0.015,1,0);
  else if (cycle>=90 && cycle<180) glTranslatef(7.5 + 0.9 -(cycle-90)*0.015,1,0);
  else glTranslatef(7.5,1,0);
  ma_soupape1->dessiner();
  glPopMatrix();
  // deuxime soupape
  glPushMatrix();
  if (cycle>=540 && cycle<630) glTranslatef(7.5 + (cycle-540)*0.015,-1,0);
  else if (cycle>=630) glTranslatef(7.5 + 0.9 -(cycle-630)*0.015,-1,0);
  else glTranslatef(7.5,-1,0);
  ma_soupape2->dessiner();
  glPopMatrix();

  // piston : objet 2
  glLoadName(2);
  mon_piston->dessiner(cycle);

  // caisson : objet 1
  glLoadName(1);
  if (caisson){
     glPushMatrix();
        mon_caisson->dessiner(false);
     glPopMatrix();
  }
}



/*********************************************************/
/* fonctionnement du traitement de la slection des      */
/* objets.nmini contient le numro de l'lment          */
/* slectionn (celui de z minimum) et hits le nombre    */
/* des lments se trouvant "sous" le clic               */
/*********************************************************/
void processHits(GLint hits, GLuint buffer[]){

   GLuint names, *ptr, zmini, nmini=-1;

   ptr = (GLuint *) buffer;

   names = ptr[0];
   zmini = ptr[1];
   // ptr[2] contient la profondeur maximale
   nmini = ptr[3];

   if (nmini == 1) elementSelectione = _ELEMENT_CAISSON;
   else if(nmini == 2) elementSelectione = _ELEMENT_PISTON;
   else if(nmini == 3) elementSelectione = _ELEMENT_SOUPAPES;
   if (hits == 0) elementSelectione = _ELEMENT_AUCUN;
}



/*********************************************************/
/* fonction de slection des objets en-dessous du        */
/* curseur                                               */
/*********************************************************/
void selection(int x, int y){
  GLuint selectBuf[_SELECTION_BUFFER_SIZE];
  GLint hits;
  GLint viewport[4];

  glGetIntegerv(GL_VIEWPORT,viewport);
  glSelectBuffer(_SELECTION_BUFFER_SIZE,selectBuf);
  glRenderMode(GL_SELECT);

  // initialisation de la pile de son nom (-1 nom par dfaut)
  glInitNames();
  glPushName(-1);

  // mise en place de la matrices de projection (cohrente avec l'affichage)
  glMatrixMode(GL_PROJECTION);
  glPushMatrix();
  glLoadIdentity();

  // filtrage de la zone de slection (ici un bloc de 9 pixel centrs sur x,y)
  gluPickMatrix((float) x, (float) (viewport[3]-y),3.0,3.0,viewport);
  gluPerspective(20.0,windowRapport,1.0,20.0);

  // mise en place de la matrice de modlisation (cohrente avec l'affichage)
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glLoadIdentity();


  // il faut ici dessiner la scne en nommant les lments slectionnables
  // placement de la scne en fonction de la camra
  gluLookAt(oeilx,oeily,oeilz,visex,visey,visez,0.0,0.0,1.0);
  // Zoom
  glScalef(zoom,zoom,zoom);
  dessinerSceneNommee();
  // fin de la partie 3D. Voir plus haut "modification de la matrice de la projection"
  glPopMatrix();

  glMatrixMode(GL_PROJECTION);
  glPopMatrix();
  glFlush();
  hits = glRenderMode(GL_RENDER);
  processHits(hits, selectBuf);
}



/*********************************************************/
/* fonction d'initialisation des paramtres de rendu et  */
/* des objets de la scnes.                              */
/*********************************************************/
static void init(){
  // couleur du fond (noir)
  glClearColor(0.05,0.05,0.05,0.0);

  // activation du ZBuffer
  glEnable(GL_DEPTH_TEST);

  // lumieres
  glEnable(GL_LIGHTING);
  // glEnable(GL_LIGHT0);   // lumire globale diffuse (il fait noir dans un moteur!)
  // glEnable(GL_LIGHT1);   // la bougie n'est pas allum par dfaut
  glEnable(GL_LIGHT2);   // lumire 2 : spot stable 1
  glEnable(GL_LIGHT3);   // lumire 3 : spot stable 2
  glEnable(GL_LIGHT4);   // lumire 4 : spot stable 3


  // normalisation
  glEnable(GL_NORMALIZE);

  // lissage des couleurs sur les facettes
  glShadeModel(GL_SMOOTH);

  // objets
  mon_repere = new Repere();
  mon_caisson = new Caisson();
  mon_piston = new Piston();
  mon_gaz = new Gaz();
  ma_soupape1 = new Soupape();
  ma_soupape2 = new Soupape();
}


/*********************************************************/
/*                    credits                            */
/*********************************************************/
void credits (void){
  cout<<"                         *********************************"<<endl
      <<"                            Projet: Moteur  explosion"<<endl
      <<"                           Georges CAMY / Arnaud QUENUM"<<endl
      <<"                                  SITR - OPEN GL "<<endl
      <<"                                       IMAC 3   "<<endl
      <<"                         *********************************"<<endl;
}


/*********************************************************/
/*                    main                               */
/*********************************************************/
int main(int argc, char** argv){
  //credit
  credits();

  // traitement des paramtres du programme propres  GL
  glutInit(&argc, argv);
  // initialisation du mode d'affichage :
  // RVB + Double buffer.
  glutInitDisplayMode(GLUT_RGBA|GLUT_DEPTH|GLUT_DOUBLE);

  // placement et dimentions initiales de la fentre
  glutInitWindowPosition(0, 0);
  glutInitWindowSize(windowWidth,windowHeight);
  // ouverture de la fentre de visualisation 3D
  if (glutCreateWindow("Moteur  explosion (essence, 4 temps)") == GL_FALSE)
  { return 1;
  }

  init();

  // association de la fonction de dimensionnement
  glutReshapeFunc(reshapeFunc);
  // association de la fonction d'affichage
  glutDisplayFunc(drawFunc);
  // association des fonctions d'vnement du clavier
  glutKeyboardFunc(kbdFunc);
  glutSpecialFunc(kbdSpecialFunc);
  // association de la fonction d'vnement souris
  glutMouseFunc(mouseFunc);
  // association de la fonction de DRAG
  glutMotionFunc(motionFunc);
  // association de la fonction d'animation
  glutIdleFunc(idleFunc);

  // boucle principale de gestion des vnements 
  glutMainLoop();

  return 0;
}

